#include <bits/stdc++.h>
using namespace std;

long long mod =  1000000009;

// a slow O(S^2) solution
long long solve_slow(int C, long long S) { // O(S^2)
    long long ret = 0;
    for (long long D = -S; D < 0; D++) 
            for (long long b =  -1LL*(C-1)*D; b <= S; b++) 
        ret = (ret+(S-b+1)*(S-b-D+1))%mod;
    ret = (2*ret)%mod;
    long long a = S+1, b = S+2, c = 2*S+3;
    if (S%2 == 0) b /= 2; else a /= 2;
    if (S%3 == 2) a /= 3; else if (S%3 == 1) b /= 3; else c /= 3;
    ret = (ret+(a*b)%mod*c)%mod;
    if (ret < 0) ret += mod;
    return ret;
}

int main() {
    int T;
    cin >> T;
    for(int t = 0; t < T; t++) {
        int C,S;
        cin >> C >> S;
        if (C == 1) {
            long long a = S+1, b = S+2;
            if (a%2 == 0) a /= 2; else b /= 2;
            long long ans = (a*b)%mod;
            if (ans < 0) ans += mod;
            cout << ans << "\n";
            continue;
        }

        vector<long long> y(5),x(5);
        for(int i = 0; i < 5; i++) { x[i]=i; y[i] = solve_slow(C,S%(C-1)+(C-1)*i); }
        
        long long ans = 0;
        long long inv[] = {1,1,500000005,666666673,750000007};
        for(int i = 0; i < 5; i++) {
            long long a = y[i];
            for(int j = 0; j < 5; j++) if (j != i) {
                a = (a*(S/(C-1)-x[j]))%mod;
                int d = x[i]-x[j];
                if (d < 0) d *=-1, a *=-1;
                a = (a*inv[d])%mod;
            }
            ans = (ans+a)%mod;
        }
        if (ans < 0) ans += mod;
        cout << ans << endl;
    }
}
